//------------------------------------LED-DECLARATION----------------------------------------
#include <FastLED.h>
CRGB led[88];
CRGB green =CRGB(0,255,0);
CRGB red =CRGB(255,0,0);
CRGB blue =CRGB(0,0,255);
CRGB orange =CRGB(255,50,0);
CRGB pink =CRGB(255,50,80);
CRGB yellow =CRGB(255,255,0);
CRGB white =CRGB(100,100,100);
CRGB off =CRGB(0,0,0);
//------------------------------------VARIABLE-DECLARATION----------------------------------------
int codeGen = 0;
int x = 0;
int y = 0;
int guessLen = 0;
int confirming = 1;
int input = 1;
int orangePegs = 0;
int greenPegs = 0;
int brightness = 5;
int silent = 0;
//------------------------------------SET-ALL----------------------------------------
void setAll(CRGB colour)
{
  int i;
  for(i = 0; i<88;++i){
    led[i] =colour;
  }
  FastLED.show();
  delay(100);
}
//------------------------------------BUZZ--------------------------------------------
void buzz()
{
  if(silent==0){
  digitalWrite(9,HIGH);
  delay(100);
  digitalWrite(9,LOW);
  }
}
//------------------------------------BOTTOM-ROW---------------------------------------
void bottomRow(CRGB x)
{
  for(int i=80;i<88;i++){
    led[i]=x;
  }
  FastLED.show();
  delay(100);
}
//------------------------------------USER-GUESS-CHECK----------------------------------
int isColourInArray(CRGB colour, CRGB array[], int arrayLen)
{
  for (int i=0;i<arrayLen;++i)
     if(colour==array[i]) return 1;
  return 0;
}
//------------------------------------ROW-COLLUM-SETUP----------------------------------
int rowcol(int x,int y)
{
  if (y%2==1)x=7-x;
  return y *8+x;
}
//------------------------------------PIN-MODE-DECLERATION------------------------------
void setup() {
  FastLED.addLeds<WS2812, 8, GRB>(led, 88);
  pinMode(0,INPUT_PULLUP);
  pinMode(1,INPUT_PULLUP);
  pinMode(2,INPUT_PULLUP);
  pinMode(3,INPUT_PULLUP);
  pinMode(4,INPUT_PULLUP);
  pinMode(5,INPUT_PULLUP);
  pinMode(6,INPUT_PULLUP);
  pinMode(7,INPUT_PULLUP);
  pinMode(A10,INPUT);
  pinMode(9,OUTPUT);
  randomSeed(analogRead(A10));
}
//-------------------------------------------ARRARY-SETUP--------------------------------
void loop() {
  int playAgain=0;
  CRGB codeColors[] = {green, red, blue, orange, pink, yellow};
  CRGB code[4] = {};
  CRGB clue[4] ={};
  CRGB userGuess[4] = {};
//-------------------------------------------CODE-GENERATION------------------------------
  for(int i=0; i < 4; i++){  // For each slot in code
    int go = 1;
    while (go==1) {
      codeGen = random(0,5);
      int isElementPresent=0;
      for (int j=0; j<i ; j++) {
        if (code[j] == codeColors[codeGen]) {
            isElementPresent = 1;
        }
      }
        if(isElementPresent==0){         
          code[i]=(codeColors[codeGen]);
          go = 0;
        }         
     }
  }
//-------------------------------------------BRIGHTNESS-AND-SOUND--------------------------
  int brightness = 5;
  FastLED.setBrightness(brightness);
  setAll(white);
  bottomRow(green);
  delay(250);
  while(confirming==1){
    if(digitalRead(1)==LOW){
      brightness = brightness+2;
      buzz();
      FastLED.setBrightness(brightness);
      FastLED.show();
      delay(100);
    }else
    if(digitalRead(7)==LOW){
      confirming = 0;
      buzz();
      setAll(off);
    }else
    if(digitalRead(2)==LOW && brightness>6){
      brightness = brightness-2;
      buzz();
      FastLED.setBrightness(brightness);
      FastLED.show();
      delay(100);
    }else
    if(digitalRead(3)==LOW && silent==!0){
      silent = 0;
      bottomRow(green);
      buzz();
      delay(100);
    }else
    if(digitalRead(6)==LOW){
      silent = 1;
      bottomRow(red);
      delay(100);
    }
  }
//-------------------------------------------USER-INPUT------------------------------------
  y = 0;
  x = 0;
  int inGame = 1;
  while(inGame==1){
    int input = 1;
    if (y==10){
      input = 0;
      }
    guessLen=0;
    while(input==1){
      confirming = 1;
      led[rowcol(x,y)] = white;
      delay(100);
      FastLED.show();
      led[rowcol(x,y)] = off;
      delay(100);
        if(digitalRead(0)==LOW){
          for(int i=0;i<guessLen;i++){
            led[rowcol(x,y)] = (off);
            x = x-1;
          }
          guessLen = 0;
        }else
        if((digitalRead(1)==LOW)&&(!isColourInArray(pink,userGuess,guessLen))){
          userGuess[guessLen] = pink;
          buzz();
          led[rowcol(x,y)] = pink;
          x = x+1;
          FastLED.show();
          guessLen = guessLen+1;
          delay(1);
        } else
        if((digitalRead(3)==LOW)&&(!isColourInArray(green,userGuess,guessLen))){
          userGuess[guessLen] = green;
          buzz();
          led[rowcol(x,y)] = green;
          x = x+1;
          FastLED.show();
          guessLen = guessLen+1;
          delay(1);
        } else
        if((digitalRead(5)==LOW)&&(!isColourInArray(orange,userGuess,guessLen))){
          userGuess[guessLen] = orange;
          buzz();
          led[rowcol(x,y)] = orange;
          x = x+1;
          FastLED.show();
          guessLen=guessLen+1;
          delay(1);
        } else
        if((digitalRead(2)==LOW)&&(!isColourInArray(blue,userGuess,guessLen))){
          userGuess[guessLen] = blue;
          buzz();
          led[rowcol(x,y)] = blue;
          x = x+1;
          FastLED.show();
          guessLen = guessLen+1;
          delay(1);
        } else
        if((digitalRead(4)==LOW)&&(!isColourInArray(yellow,userGuess,guessLen))){
          userGuess[guessLen] = yellow;
          buzz();
          led[rowcol(x,y)] = yellow;
          x = x+1;
          FastLED.show();
          guessLen = guessLen+1;
          delay(1);
        } else
        if((digitalRead(6)==LOW)&&(!isColourInArray(red,userGuess,guessLen))){
          userGuess[guessLen] = red;
          buzz();
          led[rowcol(x,y)] = red;
          x = x+1;
          FastLED.show();
          guessLen = guessLen+1;
          delay(1);
        }
        if(guessLen>3){
          input = 0;
        }
      FastLED.show();
      delay(100);
      if(guessLen==4){
        confirming = 0;
      }
      while(confirming==0){
        if(digitalRead(7)==LOW){
          buzz();
          delay(1);
          confirming = 1; 
          input = 0;
        }
        else
        if(digitalRead(0)==LOW){
          buzz();
          for (int i=0;i<4;i++){
          x = x-1;
          led[rowcol(x,y)] = off;
          }
          guessLen = 0;
          input = 1;
          confirming = 1;
          
        }
      }
    }
//-------------------------------------------CLUE-GENERATION------------------------------- 
 
      for(int i=0; i<4; i++){
        if(userGuess[i]==code[i]){
          greenPegs = greenPegs+1;
          }
        else for(int j=0; j<4; j++){
        if (userGuess[i]==code[j]){
          orangePegs = orangePegs+1;
          }
        }
      }
        for(int i=0;i<greenPegs;i++){
          led[rowcol(x,y)]=green;
          if(x<7){
          x = x+1;
          }
        }
        for(int i=0;i<orangePegs;i++){
          led[rowcol(x,y)]=orange;
          if(x<7){
          x = x+1;
          }
        }
//-------------------------------------------WIN/LOSE-DISPLAY-FUNCTION----------------------
    FastLED.show();
    delay(100);
    if(greenPegs==4){
      led[80]=green;
      led[87]=green;
       x = 2;
       y = 10;
      for(int i=0; i<4; i++){
        led[rowcol(x,y)]=code[i];
        x = x+1; }
      FastLED.show();
      delay(3000);
        int playAgain = 0;
      while(playAgain==0){
        if(digitalRead(7)==LOW){
          inGame=0;
          setAll(off);
          FastLED.show();
          delay(100);
          playAgain=1;
        }
      }
    }else
    if(y==9){
      led[80]=red;
      led[87]=red;
       x = 2;
       y = 10;
      for(int i=0; i<4; i++){
        led[rowcol(x,y)]=code[i];
        x=x+1;}
      FastLED.show();
      delay(3000);
      int playAgain=0;
      while(playAgain==0){
        if(digitalRead(7)==LOW){
          inGame=0;
          setAll(off);
          FastLED.show();
          delay(100);
          playAgain = 1;
        }
      }
    }
    y = y+1;
    x = 0;
    greenPegs = 0;
    orangePegs = 0;
    } 
}
